UPDATE APPLICATIONS SET VERSION=4.3 WHERE ID=$APP_ID{};

CREATE TABLE TICKETHISTORY (
    ORDERID VARCHAR(255) NOT NULL,
    ORDERNUMBER SMALLINT NOT NULL,
    TICKETNAME VARCHAR(255) NOT NULL,
    TICKETCONTENT MEDIUMBLOB,
    TICKETMODE SMALLINT DEFAULT 0 NOT NULL,
-- 1: Standard, 2: Restaurant 3: Delivery 4: Online 5: Waiter App 6: Purchase
    TICKETLOCATION VARCHAR(255) NOT NULL,
    TICKETDATE DATETIME NOT NULL,
	TICKETUSER VARCHAR(255),
    MONEY VARCHAR(255) NOT NULL,
    PRIMARY KEY(ORDERID),
    CONSTRAINT TH_FK_MONEY FOREIGN KEY (MONEY) REFERENCES CLOSEDCASH(MONEY)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8;

CREATE TABLE TICKETSNUM_ORDER (
    ID INTEGER NOT NULL, 
    MONEY VARCHAR(255) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO RESOURCES(ID, NAME, RESTYPE, CONTENT) VALUES('87', 'Printer.TicketOrder', 0, $FILE{/com/posics/pos/templates/Printer.TicketOrder.xml});

ALTER TABLE TICKETLINES ADD COLUMN COST DOUBLE DEFAULT 0 NOT NULL AFTER UNITS;

CREATE TABLE ZATCA_INVOICES (
    ID INT AUTO_INCREMENT PRIMARY KEY,
    RECEIPT VARCHAR(255) NOT NULL,
-- Unique Invoice Identifier
    JSON_DATA TEXT NOT NULL,
-- JSON Data of the Invoice
    STATUS VARCHAR(50) DEFAULT 'PENDING',
-- PENDING, SUCCESS, FAILED
    ATTEMPTS INT DEFAULT 0,
-- Number of Upload Attempts
    LAST_ATTEMPT DATETIME NULL,
-- Timestamp of Last Attempt
    RESPONSE_CODE VARCHAR(50) NULL,
-- ZATCA Response Code (e.g., 200, 400)
    RESPONSE_MESSAGE TEXT NULL,
-- ZATCA Response Message
    CREATED_AT DATETIME DEFAULT CURRENT_TIMESTAMP,
-- Record Creation Timestamp
    UPDATED_AT DATETIME DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
-- Record Update Timestamp
);